std::basic_ios< _CharT, _Traits >(3cxx)

NAME
std::basic_ios< _CharT, _Traits > - Template class basic_ios, virtual base class for all stream classes.

SYNOPSIS

  Public Types

typedef ctype< _CharT > __ctype_type
typedef num_get< _CharT, istreambuf_iterator< _CharT, _Traits > > __num_get_type
typedef num_put< _CharT, ostreambuf_iterator< _CharT, _Traits > > __num_put_type
typedef _CharT char_type
typedef _Traits::int_type int_type
typedef _Traits::off_type off_type
typedef _Traits::pos_type pos_type
typedef _Traits traits_type

  Public Member Functions

basic_ios (basic_streambuf< _CharT, _Traits > *__sb)
Constructor performs initialization.
virtual ~basic_ios ()
Empty.
void _M_setstate (iostate __state)
bool bad () const
Fast error checking.
void clear (iostate __state=goodbit)
[Re]sets the error state.
basic_ios & copyfmt (const basic_ios &__rhs)
Copies fields of __rhs into this.
bool eof () const
Fast error checking.
iostate exceptions () const
Throwing exceptions on errors.
void exceptions (iostate __except)
Throwing exceptions on errors.
bool fail () const
Fast error checking.
char_type fill () const
Retrieves the empty character.
char_type fill (char_type __ch)
Sets a new empty character.
bool good () const
Fast error checking.
locale imbue (const locale &__loc)
Moves to a new locale.
char narrow (char_type __c, char __dfault) const
Squeezes characters.
operator bool () const
The quick-and-easy status check.
bool operator! () const
basic_streambuf< _CharT, _Traits > * rdbuf () const
Accessing the underlying buffer.
basic_streambuf< _CharT, _Traits > * rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
Changing the underlying buffer.
iostate rdstate () const
Returns the error state of the stream buffer.
void setstate (iostate __state)
Sets additional flags in the error state.
basic_ostream< _CharT, _Traits > * tie () const
Fetches the current tied stream.
basic_ostream< _CharT, _Traits > * tie (basic_ostream< _CharT, _Traits > *__tiestr)
Ties this stream to an output stream.
char_type widen (char __c) const
Widens characters.

  Protected Member Functions

basic_ios ()
Empty.
basic_ios (const basic_ios &)=delete
void _M_cache_locale (const locale &__loc)
void init (basic_streambuf< _CharT, _Traits > *__sb)
All setup is performed here.
void move (basic_ios &&__rhs)
void move (basic_ios &__rhs)
basic_ios & operator= (const basic_ios &)=delete
void set_rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
void swap (basic_ios &__rhs) noexcept

  Protected Attributes

const __ctype_type * _M_ctype
char_type _M_fill
bool _M_fill_init
const __num_get_type * _M_num_get
const __num_put_type * _M_num_put
basic_streambuf< _CharT, _Traits > * _M_streambuf
basic_ostream< _CharT, _Traits > * _M_tie

Detailed Description

  template<typename _CharT, typename _Traits>
class std::basic_ios< _CharT, _Traits >" Template class basic_ios, virtual base class for all stream classes.

Template Parameters
    _CharT Type of character stream.
    _Traits Traits for character type, defaults to char_traits<_CharT>.

Most of the member functions called dispatched on stream objects (e.g., std::cout.foo(bar);) are consolidated in this class.

Definition at line 77 of file iosfwd.

Member Typedef Documentation

  template<typename _CharT , typename _Traits > typedef ctype<_CharT> std::basic_ios< _CharT, _Traits >::__ctype_type
These are non-standard types.

Definition at line 87 of file basic_ios.h.

  template<typename _CharT , typename _Traits > typedef _CharT std::basic_ios< _CharT, _Traits >::char_type
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 76 of file basic_ios.h.

Constructor & Destructor Documentation

  template<typename _CharT , typename _Traits > std::basic_ios< _CharT, _Traits >::basic_ios (basic_streambuf< _CharT, _Traits > * __sb) [inline], [explicit]

Constructor performs initialization. The parameter is passed by derived streams.

Definition at line 270 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::init().

  template<typename _CharT , typename _Traits > virtual std::basic_ios< _CharT, _Traits >::~basic_ios () [inline], [virtual]

Empty. The destructor does nothing. More specifically, it does not destroy the streambuf held by rdbuf().

Definition at line 282 of file basic_ios.h.

  template<typename _CharT , typename _Traits > std::basic_ios< _CharT, _Traits >::basic_ios () [inline], [protected]

Empty. The default constructor does nothing and is not normally accessible to users.

Definition at line 460 of file basic_ios.h.

Member Function Documentation

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::bad () const [inline]

Fast error checking.

Returns
    True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 211 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::rdstate().

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::clear (iostate __state = goodbit)

[Re]sets the error state.

Parameters
    __state The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 41 of file basic_ios.tcc.

Referenced by std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > basic_ios< _CharT, _Traits > & std::basic_ios< _CharT, _Traits >::copyfmt (const basic_ios< _CharT, _Traits > & __rhs)

Copies fields of __rhs into this.

Parameters
    __rhs The source values for the copies.

Returns
    Reference to this object.

All fields of __rhs are copied into this object except that rdbuf() and rdstate() remain unchanged. All values in the pword and iword arrays are copied. Before copying, each callback is invoked with erase_event. After copying, each (new) callback is invoked with copyfmt_event. The final step is to copy exceptions().

Definition at line 63 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_ios< _CharT, _Traits >::fill(), std::basic_ios< _CharT, _Traits >::tie(), and std::tie().

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::eof () const [inline]

Fast error checking.

Returns
    True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 190 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::rdstate().

  template<typename _CharT , typename _Traits > iostate std::basic_ios< _CharT, _Traits >::exceptions () const [inline]

Throwing exceptions on errors.

Returns
    The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 222 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt().

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::exceptions (iostate __except) [inline]

Throwing exceptions on errors.

Parameters
    __except The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flag is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

#include <iostream>
#include <fstream>
#include <exception>

int main()
{
    std::set_terminate (__gnu_cxx::__verbose_terminate_handler);

    std::ifstream f ("/etc/motd");

    std::cerr << "Setting badbit;
    f.setstate (std::ios_base::badbit);

    std::cerr << "Setting exception mask;
    f.exceptions (std::ios_base::badbit);
}

Definition at line 257 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::clear().

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::fail () const [inline]

Fast error checking.

Returns
    True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 201 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::rdstate().

Referenced by std::basic_ios< _CharT, _Traits >::operator bool().

  template<typename _CharT , typename _Traits > char_type std::basic_ios< _CharT, _Traits >::fill () const [inline]

Retrieves the empty character.

Returns
    The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 370 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::widen().

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), and std::basic_ios< _CharT, _Traits >::fill().

  template<typename _CharT , typename _Traits > char_type std::basic_ios< _CharT, _Traits >::fill (char_type __ch) [inline]

Sets a new empty character.

Parameters
    __ch The new character.

Returns
    The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 390 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::fill().

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::good () const [inline]

Fast error checking.

Returns
    True if no error flags are set.

A wrapper around rdstate.

Definition at line 180 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::rdstate().

  template<typename _CharT , typename _Traits > locale std::basic_ios< _CharT, _Traits >::imbue (const locale & __loc)

Moves to a new locale.

Parameters
    __loc The new locale.

Returns
    The previous locale.

Calls ios_base::imbue(loc), and if a stream buffer is associated with this stream, calls that buffer's pubimbue(loc).

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 114 of file basic_ios.tcc.

References std::ios_base::imbue().

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::init (basic_streambuf< _CharT, _Traits > * __sb) [protected]

All setup is performed here. This is called from the public constructor. It is not virtual and cannot be redefined.

Definition at line 126 of file basic_ios.tcc.

Referenced by std::basic_ios< _CharT, _Traits >::basic_ios().

  template<typename _CharT , typename _Traits > char std::basic_ios< _CharT, _Traits >::narrow (char_type __c, char __dfault) const [inline]

Squeezes characters.

Parameters
    __c The character to narrow.
    __dfault The character to narrow.

Returns
    The narrowed character.

Maps a character of char_type to a character of char, if possible.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).narrow(c,dfault)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 430 of file basic_ios.h.

  template<typename _CharT , typename _Traits > std::basic_ios< _CharT, _Traits >::operator bool () const [inline], [explicit]

The quick-and-easy status check. This allows you to write constructs such as if (!a_stream) ... and while (a_stream) ...

Definition at line 117 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::fail().

  template<typename _CharT , typename _Traits > basic_streambuf<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::rdbuf () const [inline]

Accessing the underlying buffer.

Returns
    The current stream buffer.

This does not change the state of the stream.

Definition at line 321 of file basic_ios.h.

  template<typename _CharT , typename _Traits > basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf (basic_streambuf< _CharT, _Traits > * __sb)

Changing the underlying buffer.

Parameters
    __sb The new stream buffer.

Returns
    The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument rdbuf(), which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class. For example:

std::fstream     foo;         // or some other derived type
std::streambuf*  p = .....;

foo.ios::rdbuf(p);            // ios == basic_ios<char>

Definition at line 53 of file basic_ios.tcc.

  template<typename _CharT , typename _Traits > iostate std::basic_ios< _CharT, _Traits >::rdstate () const [inline]

Returns the error state of the stream buffer.

Returns
    A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 137 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::bad(), std::basic_ios< _CharT, _Traits >::eof(), std::basic_ios< _CharT, _Traits >::fail(), std::basic_ios< _CharT, _Traits >::good(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::setstate (iostate __state) [inline]

Sets additional flags in the error state.

Parameters
    __state The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 157 of file basic_ios.h.

References std::basic_ios< _CharT, _Traits >::clear(), and std::basic_ios< _CharT, _Traits >::rdstate().

  template<typename _CharT , typename _Traits > basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie () const [inline]

Fetches the current tied stream.

Returns
    A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, std::cin is tied to std::cout.

Definition at line 295 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt().

  template<typename _CharT , typename _Traits > basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie (basic_ostream< _CharT, _Traits > * __tiestr) [inline]

Ties this stream to an output stream.

Parameters
    __tiestr The output stream.

Returns
    The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 307 of file basic_ios.h.

  template<typename _CharT , typename _Traits > char_type std::basic_ios< _CharT, _Traits >::widen (char __c) const [inline]

Widens characters.

Parameters
    __c The character to widen.

Returns
    The widened character.

Maps a character of char to a character of char_type.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).widen(c)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 449 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::fill().

Author

Generated automatically by Doxygen for libstdc++ from the source code.